// AppController.h -- the one-stop-shopping for the Stackinator.
//		      this handles all user interaction, as well
//		      as the prefs window (since both this and the
//		      prefs handling are so small, and Stackinator
//	       	      is a quick hack anyway, might as well roll
//		      them all together)

#import <Cocoa/Cocoa.h>

// hot key combination for raising the stackinator window
@class KeyCombo;



@interface AppController : NSObject
{
    // our "model"
    NSMutableArray *items;

    // only do the work in awakeFromNib once
    BOOL alreadyAwake;

    // UI elements in the primary stackinator window
    IBOutlet NSTableView *stackTableview;
    IBOutlet NSTextField *newItemTextfield;
    IBOutlet NSWindow *window;

    // UI elements in the preference window
    IBOutlet NSWindow *prefsWindow;
    IBOutlet NSButton *floatCheckbox;
    IBOutlet NSButton *hotkeyCheckbox;
    IBOutlet NSTextField *hotkeyDescription;

    // preference data
    KeyCombo *hotkeyCombo;
    BOOL floatOverAllWindows;
    BOOL hotkeyActive;
}

// UI actions
- (IBAction) pushNewItem: (id) sender;
- (IBAction) save: (id) sender;

// pref window actions

- (IBAction) changeFloatAboveAllWindows: (id) sender;
- (IBAction) changeActivateHotKey: (id) sender;
- (IBAction) changeHotKey: (id) sender;
- (IBAction) showPreferences: (id) sender;

@end // AppController

