// BWDeletableTableView.h -- interface to an NSTableView subclass that 
//			     tells its datasource to remove a row
//			     when the user presses the delete key

#import <Cocoa/Cocoa.h>

@interface BWDeletableTableView : NSTableView
{
}

@end // BWDeletableTableView


// the new method for the datasource

@interface NSObject (BWDeletableTableViewDatasourceMethod)
    
- (void) tableView: (NSTableView *) tableView
   shouldDeleteRow: (int) row;

@end // BWDeletableTableViewDelegateMethod

